Yate: Message Class Reference

Yate

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Friends | List of all members
Message Class Reference

A message container class. More...

`#include <yatengine.h>`

Inheritance diagram for Message:

## Public Member Functions
| Message (const char *name, const char *retval=0, bool broadcast=false)
| Message (const Message &original)
| Message (const Message &original, bool broadcast)
| ~Message ()
virtual void * | getObject (const String &name) const
String & | retValue ()
const String & | retValue () const
RefObject * | userData () const
void | userData (RefObject *data)
void * | userObject (const String &name) const
void | setNotify (bool notify=true)
bool | broadcast () const
Time & | msgTime ()
const Time & | msgTime () const
Message & | operator= (const char *value)
String | encode (const char *id) const
String | encode (bool received, const char *id) const
int | decode (const char *str, String &id)
int | decode (const char *str, bool &received, const char *id)
Public Member Functions inherited from NamedList
| NamedList (const char *name)
| NamedList (const NamedList &original)
| NamedList (const char *name, const NamedList &original, const String &prefix)
NamedList & | operator= (const NamedList &value)
unsigned int | length () const
unsigned int | count () const
void | clearParams ()
NamedList & | addParam (NamedString *param)
NamedList & | addParam (const char *name, const char *value, bool emptyOK=true)
NamedList & | setParam (NamedString *param)
NamedList & | setParam (const String &name, const char *value)
NamedList & | clearParam (const String &name, char childSep=0)
NamedList & | clearParam (NamedString *param, bool delParam=true)
NamedList & | copyParam (const NamedList &original, const String &name, char childSep=0)
NamedList & | copyParams (const NamedList &original)
NamedList & | copyParams (const NamedList &original, ObjList *list, char childSep=0)
NamedList & | copyParams (const NamedList &original, const String &list, char childSep=0)
NamedList & | copySubParams (const NamedList &original, const String &prefix, bool skipPrefix=true, bool replace=false)
bool | hasSubParams (const char *prefix) const
int | getIndex (const NamedString *param) const
int | getIndex (const String &name) const
NamedString * | getParam (const String &name) const
NamedString * | getParam (unsigned int index) const
const String & | operator[] (const String &name) const
const char * | getValue (const String &name, const char *defvalue=0) const
int | getIntValue (const String &name, int defvalue=0, int minvalue=INT_MIN, int maxvalue=INT_MAX, bool clamp=true) const
int | getIntValue (const String &name, const TokenDict *tokens, int defvalue=0) const
int64_t | getInt64Value (const String &name, int64_t defvalue=0, int64_t minvalue=LLONG_MIN, int64_t maxvalue=LLONG_MAX, bool clamp=true) const
double | getDoubleValue (const String &name, double defvalue=0.0) const
bool | getBoolValue (const String &name, bool defvalue=false) const
int | replaceParams (String &str, bool sqlEsc=false, char extraEsc=0) const
void | dump (String &str, const char *separator, char quote=0, bool force=false) const
ObjList * | paramList ()
const ObjList * | paramList () const
Public Member Functions inherited from String
| String ()
| String (const char *value, int len=-1)
| String (char value, unsigned int repeat=1)
| String (int32_t value)
| String (uint32_t value)
| String (int64_t value)
| String (uint64_t value)
| String (bool value)
| String (double value)
| String (const String &value)
| String (const String *value)
virtual | ~String ()
const char * | c_str () const
const char * | safe () const
const char * | safe (const char *defStr) const
unsigned int | length () const
bool | null () const
int | lenUtf8 (uint32_t maxChar=0x10ffff, bool overlong=false) const
int | fixUtf8 (const char *replace=0, uint32_t maxChar=0x10ffff, bool overlong=false)
unsigned int | encodeFlags (const TokenDict *tokens) const
uint64_t | encodeFlags (const TokenDict64 *tokens) const
const String & | decodeFlags (unsigned int flags, const TokenDict *tokens, bool unknownflag=true)
const String & | decodeFlags (uint64_t flags, const TokenDict64 *tokens, bool unknownflag=true)
bool | checkBOM () const
bool | stripBOM ()
unsigned int | hash () const
void | clear ()
char | at (int index) const
String | substr (int offs, int len=-1) const
String & | trimBlanks ()
String & | trimSpaces ()
virtual const String & | toString () const
int | toInteger (int defvalue=0, int base=0, int minvalue=INT_MIN, int maxvalue=INT_MAX, bool clamp=true) const
int | toInteger (const TokenDict *tokens, int defvalue=0, int base=0) const
long int | toLong (long int defvalue=0, int base=0, long int minvalue=LONG_MIN, long int maxvalue=LONG_MAX, bool clamp=true) const
int64_t | toInt64 (int64_t defvalue=0, int base=0, int64_t minvalue=LLONG_MIN, int64_t maxvalue=LLONG_MAX, bool clamp=true) const
double | toDouble (double defvalue=0.0) const
bool | toBoolean (bool defvalue=false) const
bool | isBoolean () const
String & | toUpper ()
String & | toLower ()
char | operator[] (signed int index) const
char | operator[] (unsigned int index) const
| operator const char * () const
String & | assign (const char *value, int len=-1)
String & | assign (char value, unsigned int repeat=1)
String & | hexify (void *data, unsigned int len, char sep=0, bool upCase=false)
String & | operator= (const String &value)
String & | operator= (const String *value)
String & | operator= (const char *value)
String & | operator= (char value)
String & | operator= (int32_t value)
String & | operator= (uint32_t value)
String & | operator= (int64_t value)
String & | operator= (uint64_t value)
String & | operator= (bool value)
String & | operator= (double value)
String & | operator+= (const char *value)
String & | operator+= (char value)
String & | operator+= (int32_t value)
String & | operator+= (uint32_t value)
String & | operator+= (int64_t value)
String & | operator+= (uint64_t value)
String & | operator+= (bool value)
String & | operator+= (double value)
bool | operator== (const char *value) const
bool | operator!= (const char *value) const
bool | operator== (const String &value) const
bool | operator!= (const String &value) const
bool | operator&= (const char *value) const
bool | operator|= (const char *value) const
String & | operator<< (const char *value)
String & | operator<< (char value)
String & | operator<< (int32_t value)
String & | operator<< (uint32_t value)
String & | operator<< (int64_t value)
String & | operator<< (uint64_t value)
String & | operator<< (bool value)
String & | operator<< (double value)
String & | operator>> (const char *skip)
String & | operator>> (char &store)
String & | operator>> (UChar &store)
String & | operator>> (int &store)
String & | operator>> (unsigned int &store)
String & | operator>> (bool &store)
String & | append (const char *value, int len)
String & | append (const char *value, const char *separator=0, bool force=false)
String & | append (const ObjList *list, const char *separator=0, bool force=false)
String & | append (const ObjList &list, const char *separator=0, bool force=false)
String & | append (double value, unsigned int decimals=3)
String & | printf (const char *format,...)
String & | printf (unsigned int length, const char *format,...)
String & | appendFixed (unsigned int fixedLength, const char *str, unsigned int len=-1, char fill= ' ', int align=Left)
String & | appendFixed (unsigned int fixedLength, const String &str, char fill= ' ', int align=Left)
int | find (char what, unsigned int offs=0) const
int | find (const char *what, unsigned int offs=0) const
int | rfind (char what) const
int | rfind (const char *what) const
bool | startsWith (const char *what, bool wordBreak=false, bool caseInsensitive=false) const
bool | endsWith (const char *what, bool wordBreak=false, bool caseInsensitive=false) const
bool | startSkip (const char *what, bool wordBreak=true, bool caseInsensitive=false)
String & | extractTo (const char *sep, String &store)
String & | extractTo (const char *sep, bool &store)
String & | extractTo (const char *sep, int &store, int base=0)
String & | extractTo (const char *sep, int &store, const TokenDict *tokens, int base=0)
String & | extractTo (const char *sep, double &store)
virtual bool | matches (const String &value) const
bool | matches (const Regexp &rexp)
int | matchOffset (int index=0) const
int | matchLength (int index=0) const
String | matchString (int index=0) const
String | replaceMatches (const String &templ) const
int | matchCount () const
ObjList * | split (char separator, bool emptyOK=true) const
ObjList * | split (const Regexp &reg, bool emptyOK=true) const
String | msgEscape (char extraEsc=0) const
String | msgUnescape (int *errptr=0, char extraEsc=0) const
String | sqlEscape (char extraEsc=0) const
String | uriEscape (char extraEsc=0, const char *noEsc=0) const
String | uriUnescape (int *errptr=0) const
Public Member Functions inherited from GenObject
| GenObject ()
virtual | ~GenObject ()
virtual bool | alive () const
virtual void | destruct ()
NamedCounter * | getObjCounter () const
NamedCounter * | setObjCounter (NamedCounter *counter)

## Protected Member Functions
virtual void | dispatched (bool accepted)
Protected Member Functions inherited from String
virtual void | changed ()

## Friends
class | MessageDispatcher

## Additional Inherited Members
Public Types inherited from String
enum | Align { Left = 0, Center, Right }
Static Public Member Functions inherited from NamedList
static const NamedList & | empty ()
Static Public Member Functions inherited from String
static const String & | empty ()
static const char * | boolText (bool value)
static int | lenUtf8 (const char *value, uint32_t maxChar=0x10ffff, bool overlong=false)
static bool | checkBOM (const char *str)
static bool | stripBOM (const char *&str)
static bool | stripBOM (char *&str)
static unsigned int | hash (const char *value, unsigned int h=0)
static String | msgEscape (const char *str, char extraEsc=0)
static String | msgUnescape (const char *str, int *errptr=0, char extraEsc=0)
static String | sqlEscape (const char *str, char extraEsc=0)
static String | uriEscape (const char *str, char extraEsc=0, const char *noEsc=0)
static String | uriEscape (const char *str, const char *extraEsc, const char *noEsc=0)
static String | uriUnescape (const char *str, int *errptr=0)
static const String * | atom (const String *&str, const char *val)
Static Public Member Functions inherited from GenObject
static void * | getObject (const String &name, const GenObject *obj)
static bool | getObjCounting ()
static void | setObjCounting (bool enable)
static NamedCounter * | getObjCounter (const String &name, bool create=true)
static ObjList & | getObjCounters ()

## Detailed Description

A message container class.

This class holds the messages that are moved around in the engine.

## Constructor & Destructor Documentation

Message | ( | const char * | name,
|  | const char * | retval = `0`,
|  | bool | broadcast = `false`
| ) |  |
| explicit

Creates a new message.

Parameters

  name | Name of the message - must not be NULL or empty
  retval | Default return value
  broadcast | Broadcast flag, true if handling the mesage must not stop it

Message | ( | const Message & | original | ) |

Copy constructor. Note that user data and notification are not copied

Parameters

  original | Message we are copying from

Message | ( | const Message & | original,
|  | bool | broadcast
| ) |  |

Copy constructor that can alter the broadcast flag. Note that user data and notification are not copied

Parameters

  original | Message we are copying from
  broadcast | Broadcast flag, true if handling the mesage must not stop it

~Message | ( |  | ) |

Destruct the message and dereferences any user data

## Member Function Documentation

bool broadcast | ( |  | ) | const
| inline

Retrieve the broadcast flag

Returns
  True if the message is a broadcast (handling does not stop it)

int decode | ( | const char * | str,
|  | String & | id
| ) |  |

Decode a string from an external communication interface for processing in the engine. The message is modified accordingly.

Parameters

  str | String to decode
  id | A String object in which the identifier is stored

Returns
  -2 for success, -1 if the string was not a text form of a message, index of first erroneous character if failed

int decode | ( | const char * | str,
|  | bool & | received,
|  | const char * | id
| ) |  |

Decode a string from an external communication interface that is an answer to a specific external processing request.

Parameters

  str | String to decode
  received | Pointer to variable to store the dispatch return value
  id | The identifier expected

Returns
  -2 for success, -1 if the string was not the expected answer, index of first erroneous character if failed

virtual void dispatched | ( | bool | accepted | ) |
| protectedvirtual

Notify the message it has been dispatched. The default behaviour is to call the dispatched() method of the user data if it implements MessageNotifier

Parameters

  accepted | True if one handler accepted the message

String encode | ( | const char * | id | ) | const

Encode the message into a string adequate for sending for processing to an external communication interface

Parameters

  id | Unique identifier to add to the string

String encode | ( | bool | received,
|  | const char * | id
| ) |  | const

Encode the message into a string adequate for sending as answer to an external communication interface

Parameters

  received | True if message was processed locally
  id | Unique identifier to add to the string

virtual void* getObject | ( | const String & | name | ) | const
| virtual

Get a pointer to a derived class given that class name

Parameters

  name | Name of the class we are asking for

Returns
  Pointer to the requested class or NULL if this object doesn't implement it

Reimplemented from NamedList.

Time& msgTime | ( |  | ) |
| inline

Retrieve a reference to the creation time of the message.

Returns
  A reference to the Time when the message was created

const Time& msgTime | ( |  | ) | const
| inline

Retrieve a const reference to the creation time of the message.

Returns
  A reference to the Time when the message was created

Message& operator= | ( | const char * | value | ) |
| inline

Name assignment operator

References String::operator=().

String& retValue | ( |  | ) |
| inline

Retrieve a reference to the value returned by the message.

Returns
  A reference to the value the message will return

const String& retValue | ( |  | ) | const
| inline

Retrieve a const reference to the value returned by the message.

Returns
  A reference to the value the message will return

void setNotify | ( | bool | notify = `true` | ) |
| inline

Enable or disable notification of any MessageNotifier that was set as user data. This method must be called after userData()

Parameters

  notify | True to have the message call the notifier

RefObject* userData | ( |  | ) | const
| inline

Retrieve the object associated with the message

Returns
  Pointer to arbitrary user RefObject

void userData | ( | RefObject * | data | ) |

Set obscure data associated with the message. The user data is reference counted to avoid stray pointers. Note that setting new user data will disable any notification.

Parameters

  data | Pointer to arbitrary user data

void* userObject | ( | const String & | name | ) | const
| inline

Get a pointer to a derived class of user data given that class name

Parameters

  name | Name of the class we are asking for

Returns
  Pointer to the requested class or NULL if user object id NULL or doesn't implement it

References RefObject::getObject().

The documentation for this class was generated from the following file:

- yatengine.h